#include <iostream>
#include <cstdlib>
#include <iomanip>

using namespace std;

void mensaje_uso(void);
void tabular(float, float, float); 
inline void intercambiar(float*, float*);
inline float evalua_funcion(float);

int main(int argc, char* argv[])
{

	if(4 != argc) 
	{
		mensaje_uso();
	}else 
	{
		float limite_inferior	= atof(argv[1]);
		float limite_superior 	= atof(argv[2]);
		float incremento	    = atof(argv[3]);

		tabular(limite_inferior, limite_superior, incremento);

	}
	
	return EXIT_SUCCESS;
	
}

void mensaje_uso(void)
{
	cout<<"use: ./tabula limite_inferior limite_superior incremento"<<endl;
}

void tabular(float limite_inferior, float limite_superior, float incremento)
{
	if(limite_superior < limite_inferior) 
	{
		intercambiar(&limite_inferior, &limite_superior);
	}

	float y = evalua_funcion(limite_inferior);
	float min=y;
	float max=y;
	
	cout << fixed<< setprecision(4);
   
	while(limite_inferior <= limite_superior) 
	{
		y = evalua_funcion(limite_inferior);
		
		if(min > y) 
		{
			min = y;
		}
		
		if(max < y)
		{
			max = y;
		}
		
		cout<<limite_inferior<<" "<<y<<endl;
		
		limite_inferior += incremento;
		
	}
	
	cout<<endl<<"mín: "<<min<<endl<<"max: "<<max<<endl;
	
}

inline void intercambiar(float* limite_inferior, float* limite_superior) 
{
	float tmp = *limite_inferior;
	*limite_inferior = *limite_superior;
	*limite_superior = tmp;
}

inline float evalua_funcion(float x) 
{
	return x*x*x-2*x+3;
}
